/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function movebutton(clickedButton) {
	var testNode = clickedButton.nextSibling;
	if (testNode && testNode.getAttribute('id') == 'invisible') {
		switchNodes(clickedButton,testNode);
		return;
	}
	testNode = clickedButton.previousSibling;
	if (testNode && testNode.getAttribute('id') == 'invisible') {
		switchNodes(clickedButton,testNode);
		return;
	}
	var index = getChildIndex(clickedButton);
	testNode = clickedButton.parentNode.nextSibling;
	if (testNode) testNode = testNode.childNodes.item(index);
	if (testNode && testNode.getAttribute('id') == 'invisible') {
		switchNodes(clickedButton,testNode);
		return;
	}
	testNode = clickedButton.parentNode.previousSibling;
	if (testNode) testNode = testNode.childNodes.item(index);
	if (testNode && testNode.getAttribute('id') == 'invisible') {
		switchNodes(clickedButton,testNode);
		return;
	}
}
function switchNodes(node1,node2) {
	var newNode1 = node2.cloneNode(true);
	var newNode2 = node1.cloneNode(true);
	var parent1 = node1.parentNode;
	var parent2 = node2.parentNode;
	parent1.replaceChild(newNode1,node1);
	parent2.replaceChild(newNode2,node2);
}
function getChildIndex(node) {
	var id = node.getAttribute('id');
	var children = node.parentNode.childNodes;
	for (var i=0; i<children.length; i++) {
		if (children.item(i).getAttribute('id') == id) break;
	}
	return i;
}
