/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is tkishdemos.
 *
 * The Initial Developer of the Original Code is
 * M.D. Nauta.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


// Assume the jar is installed in the chrome directory and has the name tkishdemos.jar.
const jarFile = 'tkishdemos.jar';

function setTitle(title) {
	if (title) {
		var wins = document.getElementsByTagName('window');
		wins[0].setAttribute('title',wins[0].getAttribute('title') + title);
	}
}

function setTextBox_failure(uri) {
	// Aparently you can't open a uri which has already been opened in the application. Is this a bug (involving pref.js/user.js)?
	var textbox = document.getElementById('theTextbox');
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET',uri);
	xmlhttp.onload = function () {
		textbox.value = xmlhttp.responseText;
	};
	xmlhttp.send(null);
}

function setTextBox(filename) {
	// I need something better than this but what? XMLHttpRequest fails.
	var textbox = document.getElementById('theTextbox');
	textbox.value = fileFromArchive(filename);
	textbox.inputField.scrollTop = 480; // magic value to jump beyond the license; fails if the file is only one or two lines more than the license.
	return true;
}

function fileFromArchive(filename) {
	if (filename) {
		var dserv = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		if (!dserv) {
			alert("Can't get directory services.");
			return false;
		}
		var archiveFile= dserv.get("AChrom",Components.interfaces.nsIFile);
		archiveFile.QueryInterface(Components.interfaces.nsILocalFile);
		archiveFile.appendRelativePath(jarFile);
		if (!archiveFile.exists()) {
			alert("Can't find jar archive of this package.");
			return false;
		}
		var aZipReader = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader);
		if (!aZipReader) {
			alert("Can't create zip-reader to read package archive.");
			return false;
		}
		aZipReader.init(archiveFile);
		aZipReader.open();
		aZipReader.test(null);// superfluous?
		try {
			var fileEntry = aZipReader.getEntry(filename);
		}
		catch (e) {
			alert('Trouble reading file "' + filename +
				'" from archive: ' + e);
			return false;
		}
		var zipStream = aZipReader.getInputStream(filename);
		var scriptStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		if (!scriptStream) {
			alert("Can't create scriptable inputstream.");
			return false;
		}
		scriptStream.init(zipStream);
		if (fileEntry.realSize != scriptStream.available()) {
			alert("File size and bytestream not of equal size, whatever this may mean.")
		}
		return scriptStream.read(scriptStream.available());
		// Are the aZipReader, zipStream and scriptStream closed?
	}
}

function redisplayWindow() {
	// This fails: the processing instructions are not applied.
	// How do you reload the application if a non-xul file is displayed?
	var textbox = document.getElementById('theTextbox');
	var parser = new DOMParser();
	var newdoc = parser.parseFromString(textbox.value,'text/xml');
	window.opener.document.replaceChild(newdoc.documentElement,
		window.opener.document.documentElement);
}
